#include <iostream>
#define maxn 1200010
using namespace std;

int segD[maxn], lazy[maxn], mI;

void init(int idx, int l, int r){
    if(l == r){
        if(l == mI){
            segD[idx] = 0;
        } else {
            segD[idx] = -2e9;
        }
        return;
    }
    int mid = (l+r)/2;
    init(idx*2+1, l, mid);
    init(idx*2+2, mid+1, r);
    segD[idx] = max(segD[idx*2+1], segD[idx*2+2]);
}

void prop(int idx){
    if(lazy[idx] < 0){
        return;
    }
    if(idx*2 + 2 < maxn){
        segD[idx] = lazy[idx];
        lazy[idx*2+1] = lazy[idx];
        lazy[idx*2+2] = lazy[idx];
        lazy[idx] = -1;
    }
}

void upd(int idx, int x, int l, int r, int vL){
    prop(idx);
    if(l == r){
        segD[idx] += vL;
        return;
    }
    int mid = (l+r)/2;
    if(x > mid){
        upd(idx*2+2, x, mid+1, r, vL);
    } else {
        upd(idx*2+1, x, l, mid, vL);
    }
    segD[idx] = max(segD[idx*2+1], segD[idx*2+2]);
}

void lazyUd(int idx, int l, int r, int qL, int qR, int v){
    prop(idx);
    if(l >= qL and r <= qR){
        lazy[idx] = v;
        prop(idx);
        return;
    }
    if(l > qR or r < qL){
        return;
    }
    int mid = (l+r)/2;
    lazyUd(idx*2+1, l, mid, qL, qR, v);
    lazyUd(idx*2+2, mid+1, r, qL, qR, v);
    segD[idx] = max(segD[idx*2+1], segD[idx*2+2]);
}

int getMx(int idx, int l, int r, int qL, int qR){
    prop(idx);
    if(l >= qL and r <= qR){
        return segD[idx];
    }
    if(l > qR or r < qL){
        return -2e9;
    }
    int mid = (l+r)/2;
    int m1 = getMx(idx*2+1, l, mid, qL, qR), m2=getMx(idx*2+2, mid+1, r, qL, qR);
    //segD[idx] = max(segD[idx*2+1], segD[idx*2+2]);
    return max(m2,m1);
}

int Slamke(int N, int* A, int M, int* T, int* X, int* Y){
    int tmp = 2e9;
    for(int i =1;i <=N;++i){
        tmp = min(A[i], tmp);
    }
    for(int i =1;i <=N;++i){
        if(A[i] == tmp){
            mI = i;
        }
    }
    init(0, 1, N);
    for(int i =0;i<maxn;++i){
        lazy[i]=-1;
    }
    for(int i = 1;i<=M;++i){
        if(T[i] == 2){
            upd(0, X[i],1, N, 1);
        } else {
            int tM = getMx (0, 1, N, X[i], Y[i]);
            lazyUd(0, 1, N, X[i], Y[i], tM);
        }
    }
    return getMx(0, 1, N, 1, N);
}